// BOSCH BME280のデータシート
// http://www.ne.jp/asahi/o-family/extdisk/BME280/BME280_DJP.pdf
// SWITCHSCIENCE
// BME280搭載　温湿度・気圧センサモジュールの使い方
// http://trac.switch-science.com/wiki/BME280
// Pythonのサンプルコード
// https://github.com/SWITCHSCIENCE/samplecodes/tree/master/1796_RPi_EnvSensor/Python_RPi
// Wiringpiのレファレンス
// http://wiringpi.com/reference/i2c-library/
// を参考にしています

#pragma once

#include "stdThread.h"

class CBME280
{
public:
	CBME280();
	~CBME280();

	BOOL Setup(int iDevId, LPSTR pszBusName = NULL);
	double readTemp();
	double readPres();
	double readHum();

private:
	int		m_fdI2C;			// I2Cのファイルディスクリプタ
	
	// データ補正用編数
	int		m_iTfine;

	UINT m_uDig_T1;
	int m_iDig_T2;
	int m_iDig_T3;

	UINT m_uDig_P1;
	int m_iDig_P2;
	int m_iDig_P3;
	int m_iDig_P4;
	int m_iDig_P5;
	int m_iDig_P6;
	int m_iDig_P7;
	int m_iDig_P8;
	int m_iDig_P9;

	BYTE m_bDig_H1;
	int m_iDig_H2;
	BYTE m_bDig_H3;
	int m_iDig_H4;
	int m_iDig_H5;
	int m_iDig_H6;

	BOOL writeReg(BYTE reg_address, BYTE data);
	void readRegs(BYTE reg_address, int iNum, BYTE* data);
	void readTrim();
	int calibration_T(int adc_T);
	UINT calibration_P(int adc_P);
	UINT calibration_H(int adc_H);
};

