#pragma once
#include "ThreadJob.h"

class CBME280;
class CSendRecvThread;           // ★

class CGetTemPreHumThread :
    public CThreadJob
{
public:
    CGetTemPreHumThread(int iDevId = -1, LPSTR pszBusName = NULL);
    CGetTemPreHumThread(LPSTR pszUserName, CSendRecvThread *pCSendRecvThread, int iDevId = -1, LPSTR pszBusName = NULL);
    ~CGetTemPreHumThread();

    // 基底クラスの関数をオーバーライドする
    // C++11で明示的にoverrideを書くことが出来るようになりました
    // 基底クラスの当該関数にvirtualが書いていないとエラーを出してくれます
    UINT DoWork() override;

private:
    CBME280         *m_pCBME280;
    char	        m_szUserName[81];					// UserName UTF-8(nullターミネートあり)
    CSendRecvThread  *m_pCSendRecvThread;

    BOOL	 SendTemPreHum1Packet(double dbTem, double dbPre, double dbHum);    // ★
    BOOL	 SendTemPreHum2Packet(double dbTem, double dbPre, double dbHum);    // ★
    BOOL	 SendTemPreHum3Packet(double dbTem, double dbPre, double dbHum);    // ★
};

