#pragma once

typedef struct
{
	int		iSize;				// キューに格納されるデータのサイズ
	LPBYTE	pbData;				// データ
} QueingDataRec;

class	CMySyncObject;

class CQueingArray  
{
public:
	CQueingArray(long lQueSize, BOOL fUseLock = FALSE);
	virtual ~CQueingArray();

	void			PushData(LPBYTE pbData, int iSize);
	void			PopData(LPBYTE *ppbData, int *piSize);
	long			GetSize();
	BOOL			CheckEnablePush();
	void			Dump();

private:
	long			m_lMaxQueSize;
	long			m_lAllocSize;
	long			m_lHead;
	long			m_lTail;
	QueingDataRec	*m_pQueingData;
	BOOL			m_fUseLock;				// 同期を使用するか
	CMySyncObject	*m_pCMySyncObject;
};


