#include "ThreadJob.h"

//----------------------------------------------
// function
//    コンストラクタ
// parameter
//    MyDataRec *pData	[in]機能に必要な情報
// return
//    なし
//----------------------------------------------
CThreadJob::CThreadJob(void)
{
    // メンバ変数の初期化
    m_idThread = 0;
    m_fStopFlag = FALSE;
}

//----------------------------------------------
// function
//    デストラクタ
// parameter
//    なし
// return
//    なし
//----------------------------------------------
CThreadJob::~CThreadJob()
{
}

//----------------------------------------------
// function
//		スレッド開始
// parameter
//		なし
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CThreadJob::Begin()
{
	int		iRet;
	BOOL    fRet;

	m_fStopFlag = FALSE;
	// ThreadProcがクラスメンバにアクセスできるように
	// クラスのインスタンスのポインタ(派生クラスのポインタと同じ)を引数として渡す
	iRet = pthread_create(&m_idThread, NULL, ThreadFunc, this);
	fRet = (iRet != 0) ? FALSE : TRUE;
	return(fRet);
}

//----------------------------------------------
// function
//		スレッドへ終了を通知
// parameter
//		なし
// return
//		なし
//----------------------------------------------
void CThreadJob::End()
{
	m_fStopFlag = TRUE;
}

//----------------------------------------------
// function
//		スレッド終了を待つ
// parameter
//		なし
// return
//		スレッドで実行した関数の戻り値
//----------------------------------------------
DWORD CThreadJob::WaitForEnd()
{
	DWORD	dwRet;
	void* pResult;

	pthread_join(m_idThread, &pResult);
	dwRet = *(DWORD*)pResult;
	SAFE_FREE(pResult)			// 返り値を使うときは開放を忘れず
	return(dwRet);
}

//----------------------------------------------
// function
//		別スレッドで実行する関数
//		派生クラスでオーバライドされるDoWorkを呼び出す
// parameter
//		void *pvoid	[in]CThreadJobのインスタンス
// return
//		実行結果
//----------------------------------------------
void* CThreadJob::ThreadFunc(void* pvoid)
{
	DWORD* pdwResult = (DWORD*)calloc(1, sizeof(DWORD));	// 返す値はエリアを確保		
	CThreadJob* pCThreadJob = (CThreadJob*)pvoid;

	*pdwResult = pCThreadJob->DoWork();						// 派生クラスのDoWork()が実行される(virtualと宣言しているので)

	cout << "ThreadFunc End" << endl;						// pthread_exitより前に書かないと実行されません
	pthread_exit(pdwResult);								// 返す値はこの関数に渡す
	return(NULL);
}
