#pragma once

#include "stdThread.h"

class CThreadJob
{
public:									// 外部から見える
	CThreadJob();						// コンストラクタ newで実行される関数
	~CThreadJob();						// デストラクタ deleteで実行される関数

	BOOL 	Begin();					// スレッドを開始する
	void 	End();						// スレッドを停止
	DWORD 	WaitForEnd();				// 停止するまで待つ
	// 派生クラスの実行内容を記述したDoWorkでオーバライド
	virtual UINT 	DoWork() = 0;

private:
	pthread_t    m_idThread;			// スレッドid 終了待ちに使用
// pthread_createに渡す関数
// グローバル(クラスのインスタンスとは無関係)に配置されます
// 当然クラスのメンバにはアクセスできないので
// クラスのインスタンス(this)をパラメータとして渡して呼び出す
	static void* ThreadFunc(void* pvoid);

protected:
	volatile BOOL m_fStopFlag;			// 終了用フラグ
};

